<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>pam_pkcs11: strings.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">pam_pkcs11
   &#160;<span id="projectnumber">0.6.11</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_fdedb0aba14d44ce9d99bc100e026e6a.html">common</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">strings.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="strings_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * PAM-PKCS11 string tools</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Copyright (C) 2005 Juan Antonio Martinez &lt;jonsito@teleline.es&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * pam-pkcs11 is copyright (C) 2003-2004 of Mario Strasser &lt;mast@gmx.net&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * This library is free software; you can redistribute it and/or</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * modify it under the terms of the GNU Lesser General Public</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * License as published by the Free Software Foundation; either</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * version 2.1 of the License, or (at your option) any later version.</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * This library is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * Lesser General Public License for more details.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * You should have received a copy of the GNU Lesser General Public</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * License along with this library; if not, write to the Free Software</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * $Id$</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#ifndef __STRINGS_H_</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#define __STRINGS_H_</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifdef HAVE_CONFIG_H</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;config.h&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;stdlib.h&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;string.h&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#ifndef _STRINGS_C_</span></div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">   37</a></span>&#160;<span class="preprocessor">#define M_EXTERN extern</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#define M_EXTERN</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<a class="code" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> <span class="keywordtype">int</span> <a class="code" href="strings_8h.html#a9631e70f79c6394494793f7c52c0b194">is_empty_str</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *str);</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<a class="code" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> <span class="keywordtype">char</span> *<a class="code" href="strings_8h.html#a371a8cb3e3e24b794a5a871fff24242e">clone_str</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *str);</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<a class="code" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> <span class="keywordtype">char</span> *<a class="code" href="strings_8h.html#ae73c7044be9e0f7e49ef2fecc0e1c143">toupper_str</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *str);</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<a class="code" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> <span class="keywordtype">char</span> *<a class="code" href="strings_8h.html#ae51f5a5400748bc9b8b50f4d3480d588">tolower_str</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *str);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<a class="code" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> <span class="keywordtype">char</span> *<a class="code" href="strings_8h.html#a24e94eaf64482af3501c9f060b73d6f7">bin2hex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> *binstr,<span class="keyword">const</span> <span class="keywordtype">int</span> len);</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<a class="code" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> *<a class="code" href="strings_8h.html#ae3f4c76d88e1efa97cb1d057c2abdc80">hex2bin</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *hexstr);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<a class="code" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> *<a class="code" href="strings_8h.html#a827a0b95a57290a2d2059d712cb168ee">hex2bin_static</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *hexstr,<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> **res,<span class="keywordtype">int</span> *size);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<a class="code" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> <span class="keywordtype">char</span> **<a class="code" href="strings_8h.html#a9b7df0677fdea0c65c0faddfc40ff7ad">split</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *str,<span class="keywordtype">char</span> sep, <span class="keywordtype">int</span> nelems);</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<a class="code" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> <span class="keywordtype">char</span> **<a class="code" href="strings_8h.html#a5d3af2a4e490a5b521b7b2f22c6a4bbf">split_static</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *str,<span class="keywordtype">char</span> sep, <span class="keywordtype">int</span> nelems,<span class="keywordtype">char</span> *dst);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<a class="code" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> <span class="keywordtype">char</span> *<a class="code" href="strings_8h.html#ac255ca3660b53737550b93d1020a1dd2">trim</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *str);</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="preprocessor">#undef M_EXTERN</span></div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="strings_8h_html_a9631e70f79c6394494793f7c52c0b194"><div class="ttname"><a href="strings_8h.html#a9631e70f79c6394494793f7c52c0b194">is_empty_str</a></div><div class="ttdeci">M_EXTERN int is_empty_str(const char *str)</div><div class="ttdoc">Check for a null or spaced string. </div></div>
<div class="ttc" id="strings_8h_html_ae51f5a5400748bc9b8b50f4d3480d588"><div class="ttname"><a href="strings_8h.html#ae51f5a5400748bc9b8b50f4d3480d588">tolower_str</a></div><div class="ttdeci">M_EXTERN char * tolower_str(const char *str)</div><div class="ttdoc">Duplicate a string converting all chars to lower-case. </div></div>
<div class="ttc" id="strings_8h_html_a24e94eaf64482af3501c9f060b73d6f7"><div class="ttname"><a href="strings_8h.html#a24e94eaf64482af3501c9f060b73d6f7">bin2hex</a></div><div class="ttdeci">M_EXTERN char * bin2hex(const unsigned char *binstr, const int len)</div><div class="ttdoc">Convert a byte array into a colon-separated hexadecimal sequence. </div></div>
<div class="ttc" id="strings_8h_html_a5d3af2a4e490a5b521b7b2f22c6a4bbf"><div class="ttname"><a href="strings_8h.html#a5d3af2a4e490a5b521b7b2f22c6a4bbf">split_static</a></div><div class="ttdeci">M_EXTERN char ** split_static(const char *str, char sep, int nelems, char *dst)</div><div class="ttdoc">Splits a string to an array of nelems by using sep as character separator, using dest as pre-allocate...</div></div>
<div class="ttc" id="strings_8h_html_ae3f4c76d88e1efa97cb1d057c2abdc80"><div class="ttname"><a href="strings_8h.html#ae3f4c76d88e1efa97cb1d057c2abdc80">hex2bin</a></div><div class="ttdeci">M_EXTERN unsigned char * hex2bin(const char *hexstr)</div><div class="ttdoc">Convert a colon-separated hexadecimal data into a byte array. </div></div>
<div class="ttc" id="strings_8h_html_a827a0b95a57290a2d2059d712cb168ee"><div class="ttname"><a href="strings_8h.html#a827a0b95a57290a2d2059d712cb168ee">hex2bin_static</a></div><div class="ttdeci">M_EXTERN unsigned char * hex2bin_static(const char *hexstr, unsigned char **res, int *size)</div><div class="ttdoc">Convert a colon-separated hexadecimal data into a byte array, store result into a previously allocate...</div></div>
<div class="ttc" id="strings_8h_html_ae73c7044be9e0f7e49ef2fecc0e1c143"><div class="ttname"><a href="strings_8h.html#ae73c7044be9e0f7e49ef2fecc0e1c143">toupper_str</a></div><div class="ttdeci">M_EXTERN char * toupper_str(const char *str)</div><div class="ttdoc">Duplicate a string converting all chars to upper-case. </div></div>
<div class="ttc" id="strings_8h_html_a9b7df0677fdea0c65c0faddfc40ff7ad"><div class="ttname"><a href="strings_8h.html#a9b7df0677fdea0c65c0faddfc40ff7ad">split</a></div><div class="ttdeci">M_EXTERN char ** split(const char *str, char sep, int nelems)</div><div class="ttdoc">Splits a string to an array of nelems by using sep as character separator. </div></div>
<div class="ttc" id="strings_8h_html_a371a8cb3e3e24b794a5a871fff24242e"><div class="ttname"><a href="strings_8h.html#a371a8cb3e3e24b794a5a871fff24242e">clone_str</a></div><div class="ttdeci">M_EXTERN char * clone_str(const char *str)</div><div class="ttdoc">Duplicate a string. </div></div>
<div class="ttc" id="strings_8h_html_ae3fd0a2c68f60144e9b18b1ba45763e1"><div class="ttname"><a href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a></div><div class="ttdeci">#define M_EXTERN</div><div class="ttdoc">String management library. </div><div class="ttdef"><b>Definition:</b> <a href="strings_8h_source.html#l00037">strings.h:37</a></div></div>
<div class="ttc" id="strings_8h_html_ac255ca3660b53737550b93d1020a1dd2"><div class="ttname"><a href="strings_8h.html#ac255ca3660b53737550b93d1020a1dd2">trim</a></div><div class="ttdeci">M_EXTERN char * trim(const char *str)</div><div class="ttdoc">Remove all extra spaces from a string. </div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed May 22 2019 12:09:34 for pam_pkcs11 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
